#include	<stdio.h>

#include	"stringid.h"


static	void	Test( const char *path )
{
	int		ret, id;
	SISrc	src;
	SIStat	st;
	hSISet	set;
	hSIDic	dic;
	const char	*s;

	ret = SISet_Open( &set );
	fprintf( stderr, "SISet_Open(): %s\n", SIDic_Error( ret ) );

	ret = SISet_Load( set, path, "\t\r\n" );
	fprintf( stderr, "SISet_Load( \"%s\" ): %s\n", path, SIDic_Error( ret ) );

	ret = SIDic_Build( &dic, set );
	fprintf( stderr, "SIDic_Build(): %s\n", SIDic_Error( ret ) );

	ret = SISet_Close( set );
	fprintf( stderr, "SISet_Close(): %s\n", SIDic_Error( ret ) );

	ret = SIDic_Status( dic, &st );
	fprintf( stderr, "SIDic_Status(): %s\n", SIDic_Error( ret ) );

	fprintf( stderr, "BC: %d\n", st.nbc );
	fprintf( stderr, "TAIL: %d\n", st.ntail );
	fprintf( stderr, "SIZE: %d\n", st.size );
	fprintf( stderr, "KEY: %d\n", st.nkey );
	fprintf( stderr, "MAX: %d\n", st.maxlen );

	ret = SIDic_Save( dic, "StrId.dic" );
	fprintf( stderr, "SIDic_Save( \"%s\" ): %s\n",
			 "StrId.dic", SIDic_Error( ret ) );

	ret = SIDic_Close( dic );
	fprintf( stderr, "SIDic_Close(): %s\n", SIDic_Error( ret ) );

	ret = SIDic_Open( &dic, "StrId.dic" );
	fprintf( stderr, "SIDic_Open( \"%s\" ): %s\n",
			 "StrId.dic", SIDic_Error( ret ) );

	s = SIDic_StrToID( dic, "test", &id );
	fprintf( stderr, "SIDic_StrToID( \"%s\" ): %s: %d\n",
			 "test", ( s != NULL ) ? s : "(null)", id );

	s = SIDic_IDToStr( dic, id );
	fprintf( stderr, "SIDic_IDToStr( %d ): %s\n",
			 id, ( s != NULL ) ? s : "(null)" );

	ret = SISrc_Start( &src, "motor" );
	fprintf( stderr, "SISrc_Start( \"%s\" ): %s\n",
			 "motor", SIDic_Error( ret ) );

	while ( ( s = SIDic_Prefix( dic, &src ) ) != NULL )
		fprintf( stderr, "SIDic_Prefix( \"%s\" ): %s[%d]: %d\n",
				 src.input, s, src.len, src.id );

	ret = SISrc_Start( &src, "motor" );
	fprintf( stderr, "SISrc_Start( \"%s\" ): %s\n",
			 "motor", SIDic_Error( ret ) );

	while ( ( s = SIDic_Infix( dic, &src ) ) != NULL )
		fprintf( stderr, "SIDic_Infix( \"%s\" ): %s[%d]: %d\n",
				 src.input, s, src.len, src.id );

	ret = SIDic_Close( dic );
	fprintf( stderr, "SIDic_Close(): %s\n", SIDic_Error( ret ) );
}

int		main( int argc, char *argv[] )
{
	int		i;

	for ( i = 1; i < argc; i++ )
		Test( argv[i] );

	return	0;
}
